{% extends "base.html" %} {% load static %}

{% block css %}

<link href="https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.6-rc.0/css/select2.min.css" rel="stylesheet" />
<link rel="stylesheet" type="text/css" href="{% static 'css/select2.min.css' %}">
<link rel="stylesheet" type="text/css" href="{% static 'css/select2-bootstrap.css' %}">
<link rel="stylesheet" type="text/css" href="{% static 'css/pmd-select2.css' %}">
<link rel="stylesheet" type="text/css" href="{% static 'css/textfield.css' %}">
<link href="http://cdnjs.cloudflare.com/ajax/libs/summernote/0.8.4/summernote.css" rel="stylesheet">

{% endblock css %}

{% block title %}

<h1>Proponer Proyectos</h1>
<ol class="breadcrumb">
    <li>
        <a style="cursor: default; color: white;">Dashboard</a>
    </li>
    <li>
        <a style="cursor: default; color: white;">Proyectos</a>
    </li>
    <li style="cursor: default;" class="active">Proponer Proyectos</li>
</ol>
{% endblock title %} {% block content %}
<div>
    <div id="content" class="container-fluid row">
        <div class="col-sm-3">
            <a href="{% url 'my_projects' %}?filter=proposed">
                <div class="card">
                    <header class="card-heading card-blue">
                        <div class="row">
                            <div class="col-sm-7">
                                <h2 class="card-title">Proyectos propuestos</h2>
                            </div>
                            <div class="col-sm-5">
                                <i class="zmdi zmdi-hc-3x zmdi-file-plus"></i>
                            </div>
                        </div>
                    </header>
                    <div class="card-body text-center">
                        <div class="row">
                            <div class="col-sm-12">
                                <h4 class="font-size-30">{{cant_prop}}</h4>
                                <h4>Propuestas</h4>
                            </div>                        
                        </div>
                    </div>
                </div>
            </a>
        </div>
        <div class="col-sm-3">
            <a href="{% url 'my_projects' %}?filter=revision">
                <div class="card">
                    <header class="card-heading card-yellow">
                        <div class="row">
                            <div class="col-sm-7">
                                <h2 class="card-title">Propuestas en revisión</h2>
                            </div>
                            <div class="col-sm-5">
                                <i class="zmdi zmdi-hc-3x zmdi-assignment-alert"></i>
                            </div>
                        </div>
                    </header>
                    <div class="card-body text-center">
                        <div class="row">
                            <div class="col-sm-12">
                                <h4 class="font-size-30">{{prop_er}}</h4>
                                <h4>Propuestas</h4>
                            </div>
                        </div>
                    </div>
                </div>
            </a>
        </div>
        <div class="col-sm-3">
            <a href="{% url 'my_projects' %}?filter=approved">
                <div class="card">
                    <header class="card-heading card-purple">
                        <div class="row">
                            <div class="col-sm-7">
                                <h2 class="card-title">Propuestas aprobadas</h2>
                            </div>
                            <div class="col-sm-5">
                                <i class="zmdi zmdi-hc-3x zmdi-badge-check"></i>
                            </div>
                        </div>
                    </header>
                    <div class="card-body text-center">
                        <div class="row">
                            <div class="col-sm-12">
                                <h4 class="font-size-30">{{prop_ap}}</h4>
                                <h4>Propuestas</h4>
                            </div>
                        </div>
                    </div>
                </div>
            </a>
        </div>
        <div class="col-sm-3">
            <a href="{% url 'my_projects' %}?filter=rejected">
                <div class="card">
                    <header class="card-heading card-accent">
                        <div class="row">
                            <div class="col-sm-7">
                                <h2 class="card-title">Propuestas rechazadas</h2>
                            </div>
                            <div class="col-sm-5">
                                <i class="zmdi zmdi-hc-3x zmdi-close-circle-o"></i>
                            </div>
                        </div>
                    </header>
                    <div class="card-body text-center">
                        <div class="row">
                            <div class="col-sm-12">
                                <h4 class="font-size-30">{{prop_re}}</h4>
                                <h4>Propuestos</h4>
                            </div>
                        </div>
                    </div>
                </div>
            </a>
        </div>
        <div id="propose" class="col-sm-12 col-sm-12">
            <div class="card">
                <header class="card-heading card-default">
                    <h2 class="card-title">Formulario de Propuesta</h2>
                </header>
                <div class="card-body">
                    <form action="" class="" id="form-horizontal">
                        <div class="row">
                            <div class="col-sm-4 col-md-4">
                                <div class="form-group">
                                    <label for="facultad" class="control-label">Facultad:</label>
                                    <select id="facultad" class=" select-with-search pmd-select2 pmd-select2-tags pmd-textfield-floating-label pmd-textfield form-control" data-rule-required="true" aria-required="true">
                                        <option>Elija una facultad ...</option>
                                        <option value="1">Facultad de Ingeniería</option>
                                    </select>
                                </div>
                            </div>
                            <div class="col-sm-4 col-md-4">
                                <div class="form-group">
                                    <label for="carrera" class="control-label">Carrera:</label>
                                    <select id="carrera" class="select-with-search pmd-select2 pmd-select2-tags pmd-textfield-floating-label pmd-textfield form-control form-control" data-rule-required="true" aria-required="true">
                                        <option>Elija una carrera ...</option>
                                        {% for carreer in carreers %}
                                        <option value="{{carreer.1}}">{{carreer.0}}</option>
                                        {% endfor %}
                                    </select>
                                </div>
                            </div>
                            <div class="col-sm-2 col-md-2">
                                <div class="form-group">
                                    <label for="anio" class="control-label">Año:</label>
                                    <input type="number" name="anio" id="anio" class="form-control"></input>
                                </div>
                            </div>
                            <div class="col-sm-2 col-md-2">
                                <div class="form-group">
                                    <label for="periodo" class="control-label">Período:</label>
                                    <select id="periodo" class="select-with-search pmd-select2 pmd-select2-tags pmd-textfield-floating-label pmd-textfield form-control form-control" data-rule-required="true" aria-required="true">
                                        <option>Elija un período ...</option>
                                        {% for periodo in periods %}
                                        <option value="{{periodo.0}}">{{periodo.1}}</option>
                                        {% endfor %}
                                    </select>
                                </div>
                            </div>
                        </div>
                        <div class="" id="step2">
                            <div class="row">
                                <div class="col-sm-2 col-md-2">
                                    <div class="form-group">
                                        <label for="cupos" class="control-label">Cupos:</label>
                                        <input id="cupos" type="text" name="cupos" placeholder="Ingrese cantidad de cupos..." data-rule-required="true" data-rule-range="[1,40]"
                                            class="form-control" aria-required="true" title="Valores admitidos entre 1 y 40" oninvalid="this.setCustomValidity('Campo requerido')">
                                    </div>
                                </div>
                                <div class="col-sm-6 col-md-6">
                                    <div class="form-group">
                                        <label class="" for="estudiantes">Estudiantes:</label>
                                        <select id="estudiantes" class="form-control select-with-search pmd-select2 pmd-select2-tags pmd-textfield-floating-label pmd-textfield form-control" multiple="multiple">
                                        </select>
                                    </div>
    
                                </div>
                                <div class="col-sm-4 col-md-4">
                                    <div class="form-group">
                                        <label for="teacher" class="control-label">Profesor:</label>
                                        <select id="teacher" class="select-with-search pmd-select2 pmd-select2-tags pmd-textfield-floating-label pmd-textfield form-control form-control">
                                        </select>
                                    </div>
                                </div>
                            </div>
                            <div class="row">
                                <div class="col-sm-8 col-md-8">
                                    <div class="form-group">
                                        <label for="titulo" class="control-label">Título:</label>
                                        <input id="titulo" type="text" name="cupos" placeholder="Ingrese un título..." data-rule-required="true" class="form-control"
                                            aria-required="true">
                                    </div>
                                </div>
                                <div class="col-sm-4 col-md-4">
                                    <div class="form-group" style="margin-top:2%">
                                        <label for="cupos" class="control-label">Tags:</label>
                                        <div class="chips chips-custom"></div>
                                    </div>
                                </div>
                            </div>
                            <div class="row">
                                <div class="col-sm-12 col-md-12">
                                    <div class="form-group">
                                        <label for="descripcion">Descripción: </label>
                                        <textarea rows="5" class="form-control" data-rule-required="true" aria-required="true" name="" id="descripcion"></textarea>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </form>
                </div>
                <div class="card-footer border-top">
                    <ul class="card-actions text-center" style="padding-left: 0px;">
                        <li id="new_project">
                            <a id="submit" class="btn btn-block btn-default btn-success">
                                Aceptar
                            </a>                            
                        </li>
                        <li id="update_project" style="display:none">
                            <a id="update" valueid="" class="btn btn-block btn-default btn-warning">
                                Actualizar
                            </a>                           
                            <a id="cancel_update" class="btn btn-block btn-default btn-danger">
                                Cancelar
                            </a>                           
                        </li>
                    </ul>
                </div>
            </div>
        </div>
        
    </div>
</div>
{% endblock content %} {% block javascript %}
<script src="https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.6-rc.0/js/select2.min.js"></script>
<script src="{% static 'js/plugins/bootstrap-tagsinput/bootstrap-tagsinput.js' %}"></script>
<script src="{% static 'js/global.js' %}"></script>
<script src="{% static 'js/pmd-select2.js' %}"></script>
<script src="{% static 'js/select2.full.js' %}"></script>
<script src="{% static 'js/textfield.js' %}"></script>
<script src="https://unpkg.com/sweetalert/dist/sweetalert.min.js"></script>
<script src='https://cdnjs.cloudflare.com/ajax/libs/jquery-validate/1.17.0/jquery.validate.js'></script>
<script src="http://cdnjs.cloudflare.com/ajax/libs/summernote/0.8.4/summernote.js"></script>
<script>
    $(document).on("click", "#submit", function () {
        $("#form-horizontal").validate({
            rules: {
                facultad: {
                    required: true,
                },
                carrera: {
                    required: true,
                },
                periodo: {
                    required: true,
                    minlength: 6
                },
                cupos: {
                    required: true,
                    min: 1
                },
                estudiantes: {
                    required: true,
                },
                profesor: {
                    required: true,
                },
                titulo: {
                    required: true,
                    minlength: 20,
                    maxlength: 100,
                },
                descripcion: {
                    required: true,
                    minlength: 200,
                    maxlength: 1300,
                },
            },
            messages: {
                facultad: {
                    required: "Campo necesario.",
                },
                cupos: {
                    required: "Campo necesario.",
                    min: jQuery.validator.format("Se necesita como mínimo 1 cupo.")
                },
                periodo: {
                    required: "Campo necesario.",
                    minlength: jQuery.validator.format("Al menos {0} digitos!")
                },
                carrera: {
                    required: "Campo necesario.",
                },
                estudiantes: {
                    required: "Campo necesario.",
                },
                profesor: {
                    required: "Campo necesario.",
                },
                titulo: {
                    required: "Campo necesario.",
                    minlength: jQuery.validator.format("Al menos {0} caracteres!"),
                    maxlength: jQuery.validator.format("Como máximo {0} caracteres!"),
                },
                descripcion: {
                    required: "Campo necesario.",
                    minlength: jQuery.validator.format("Al menos {0} caracteres!"),
                    maxlength: jQuery.validator.format("Como máximo {0} caracteres!"),
                },
            }
        });
        if ($("#form-horizontal").valid()) {
            var facultad = $("#facultad").val();
            var carrera = $("#carrera").val();
            var periodo = $("#periodo").val();
            var anio = $("#anio").val();
            var cupos = $("#cupos").val();
            var estudiantes = $("#estudiantes").val();
            var profesor = $("#teacher").val();
            var titulo = $("#titulo").val();
            var descripcion = $("#descripcion").val();
            var tags = "";
            $(".chip").each(function () {
                tags = tags + $(this).html() + ",";

            });
            console.log("estos son los tags a cargar",tags);
            var data = {
                facultad: facultad,
                csrfmiddlewaretoken: '{{ csrf_token }}',
                carrera: carrera,
                periodo: periodo,
                anio: anio,
                cupos: cupos,
                estudiantes: estudiantes,
                profesor: profesor,
                titulo: titulo,
                tags: tags,
                descripcion: descripcion,

            }
            $.ajax({
                type: "post",
                url: "{% url 'create_project' %}",
                data: data,
                success: function (response) {
                    if (response.mensaje == "exito"){
                        $("#cupos").val("");
                        $("#periodo").val("");
                        $("#anio").val("");
                        $("#titulo").val("");
                        var descripcion = $("#descripcion").val("");
                        swal("Éxito!", "Propuesta enviada!", "success")
                            .then((value) => {
                                window.location.reload();
                            });
                    } else {
                        swal("Error!",response.mensaje,"warning")
                    }
                },
                error: function () {
                    swal("ERROR!", "Verificar datos ingresados e intentar nuevamente.","error")
                },
            })
        } else {
            swal("Algo salió mal!", "Verifíca los campos!", "error");
        }


    });
    $(document).on("click", "#update", function () {
        $("#form-horizontal").validate({
            rules: {
                facultad: {
                    required: true,
                },
                carrera: {
                    required: true,
                },
                periodo: {
                    required: true,
                    minlength: 2
                },
                anio: {
                    required: true,
                    minlength: 4
                },
                cupos: {
                    required: true,
                    min: 1
                },
                estudiantes: {
                    required: false,
                },
                profesor: {
                    required: true,
                },
                titulo: {
                    required: true,
                    minlength: 20,
                    maxlength: 100,
                },
                descripcion: {
                    required: true,
                    minlength: 200,
                    maxlength: 1300,
                },
            },
            messages: {
                facultad: {
                    required: "Campo necesario.",
                },
                cupos: {
                    required: "Campo necesario.",
                    min: jQuery.validator.format("Se necesita como mínimo 1 cupo.")
                },
                anio: {
                    required: "Campo necesario.",
                    minlength: jQuery.validator.format("Al menos {0} digitos!")
                },
                periodo: {
                    required: "Campo necesario.",
                    minlength: jQuery.validator.format("Al menos {0} digitos!")
                },
                carrera: {
                    required: "Campo necesario.",
                },
                estudiantes: {
                    required: "Campo necesario.",
                },
                profesor: {
                    required: "Campo necesario.",
                },
                titulo: {
                    required: "Campo necesario.",
                    minlength: jQuery.validator.format("Al menos {0} caracteres!"),
                    maxlength: jQuery.validator.format("Como máximo {0} caracteres!"),
                },
                descripcion: {
                    required: "Campo necesario.",
                    minlength: jQuery.validator.format("Al menos {0} caracteres!"),
                    maxlength: jQuery.validator.format("Como máximo {0} caracteres!"),
                },
            }
        });
        if ($("#form-horizontal").valid()) {
            var facultad = $("#facultad").val();
            var carrera = $("#carrera").val();
            var periodo = $("#periodo").val();
            var anio = $("#anio").val();
            var cupos = $("#cupos").val();
            var estudiantes = $("#estudiantes").val();
            var profesor = $("#teacher").val();
            var titulo = $("#titulo").val();
            var descripcion = $("#descripcion").val();
            var tags = ""
            $(".chip").each(function () {
                tags = tags + $(this).html() + ",";

            });
            var data = {
                info:$(this).attr('valueid'),
                facultad: facultad,
                csrfmiddlewaretoken: '{{ csrf_token }}',
                carrera: carrera,
                periodo: periodo,
                cupos: cupos,
                anio: anio,
                estudiantes: estudiantes,
                profesor: profesor,
                titulo: titulo,
                tags: tags,
                descripcion: descripcion,

            }
            $.ajax({
                type: "post",
                url: "{% url 'update_project_detail' %}",
                data: data,
                success: function (response) {
                    $("#cupos").val("");
                    $("#periodo").val("");
                    $("#titulo").val("");
                    var descripcion = $("#descripcion").val("");
                    swal("Exito!", "Propuesta actualizada!", "success")
                        .then((value) => {
                            window.location.reload();
                        });
                },
                error: function () {
                    //SWEETALERT
                },
            })
        } else {
            swal("Algo salió mal!", "Verifíca los campos!", "error");
        }


    });

    
    $(document).ready(function () {
        $("#descripcion").summernote();
        var last_valid_selection = null;
        var current_year = (new Date()).getFullYear();
        $('#anio').val(current_year);
        
        $(".select-with-search").select2({
			theme: "bootstrap"
		});

        
        $(".mipropioselect").select2();


        $('#estudiantes').change(function (event) {
            if ($(this).val().length > $("#cupos").val()) {
                $(this).val(last_valid_selection);
            } else {
                last_valid_selection = $(this).val();
            }
        });
        $(".chips-custom").material_chip({
            autocompleteOptions: {
                data: {
                    {% for tag in tags %}
					"{{tag.value}}": null,
                    {% endfor %}
				},
                limit: Infinity,
                minLength: 1
            },
            placeholder: '+ tag',
            secondaryPlaceholder: 'Ingrese un tag',
        });


        $("#periodo").change(function (e, data_lists) {
            var button = $(this);
            var pk = $("#carrera").val();
            var cycle = $("#periodo").val();
            if (cycle == 10 || cycle == 20 ){
                cycle = "RE"
            } else {
                cycle = "AD"
            }

            data = {
                pk: pk,
                cycle: cycle,
                csrfmiddlewaretoken: '{{ csrf_token }}'
            }
            load_teachers_students(data, data_lists)
        });
        {% if request.session.type == 'DO' %}
        $("#teacher").html('<option selected value="{{ request.session.rut }}">{{request.user.first_name}} {{request.user.last_name}}</option>');
        {% endif %}
        $("#prj_propose").addClass("active");
        $("#step2").hide()
    });
    
    function load_teachers_students(data, lists){
        {% if request.session.type != 'DO' %}
        $.ajax({
            type: "post",
            url: "{% url 'get_teachers' %}",
            data: data,
            success: function (response) {
                $("#teacher").html(response.html);
                if(lists!=null){
                    $('#teacher').val(lists.guide_teacher).trigger('change');
                }                
            },
            error: function () {
                //SWEETALERT
            },
        });
        {% endif %}
        $.ajax({
            type: "post",
            url: "{% url 'get_students' %}",
            data: data,
            success: function (response) {
                $("#step2").show();
                $("#estudiantes").prop("disabled", false);
                $("#estudiantes").html(response.html);
                if(lists!=null){
                    console.log("student_list");
                    console.log(lists.student_list);
                    console.log(lists);
                    $.each(lists.student_list, function(i,e){
                        var info = $('#estudiantes option[value="'+ e +'"]').text();
                        $('.dropdownjs li:contains("'+ info +'")').trigger('click');
                    });
                }
            },
            error: function () {
                //SWEETALERT
            },
        });
    }
</script> {% endblock javascript %}